
c     =========================================
      logical function allowflag(x,y,t,level)
c     =========================================

c     # Indicate whether the grid point at (x,y,t) at this refinement level
c     # is allowed to be flagged for further refinement.
c
c     # This is useful if you wish to zoom in on some structure in a 
c     # known location but don't want the same level of refinement elsewhere.  
c     # Points are flagged only if one of the errors is greater than the 
c     # corresponding tolerance.
c
c     # For example, to allow refinement of Level 1 grids everywhere but
c     # of finer grids only for  y >= 0.4:
c     # allowed(x,y,t,level) = (level.le.1 .or. y.ge.0.4d0) 
c
c     # This routine is called from routine flag2refine.
c     # If Richardson error estimates are used (if tol>0) then this routine
c     # is also called from errf1.

      implicit double precision (a-h,o-z)

c     # default version allows refinement anywhere:
      allowflag = .true.

c     if (x.lt.0.d0 .and. x.gt.-2.d0 - t/.2d0)  allowflag = .false.

c     # disallow refinement in lower hemisphere:
c     if (x.lt.-1.d0) then
c          allowflag = .false.
c          endif

c     if (x.lt.0.6d0 .or. x.gt.0.8d0)  allowflag = .false.
c     if (y.lt.0.d0)  allowflag = .false.

      return
      end
