c
c ---------------------------------------------------------------
c
        subroutine filpatch2(level,nvar,valbig,aux,naux,
     1                      time,mitot,mjtot,
     2                      nrowst,ncolst,ilo,ihi,jlo,jhi)

c :::::::::::::::::::::::::::: FILPATCH :::::::::::::::::::::::::;
c
c  fill the portion of valbig from rows  nrowst
c                             and  cols  ncolst
c  the patch can also be described by the corners (xlp,ybp) by (xrp,ytp).
c  vals are needed at time time, and level level,
c
c  first fill with  values obtainable from the level level
c  grids. if any left unfilled, then enlarge remaining rectangle of
c  unfilled values by 1 (for later linear interp), and recusively
c  obtain the remaining values from  coarser levels.
c
c :::::::::::::::::::::::::::::::::::::::;:::::::::::::::::::::::;

      implicit double precision (a-h,o-z)

      include  "call.i"
      include  "geo.i"

      logical   set, sticksout
      dimension valbig(mitot,mjtot,nvar), aux(mitot,mjtot,naux)

      dimension coarseq(3,3,maxvar)
      dimension coarseeta(3,3)
      dimension coarseb(3,3)
      dimension coarseinterp(3,3,maxvar)
      dimension fineval(maxvar)
      dimension velfine(3)
      dimension coarsevelmax(3)
      dimension coarsevelmin(3)

      logical redo


      iadflag(i,j)    =  locuse + i-1+(j-1)*nrowp
      ivalc(i,j,ivar) =  loccrse + (i - 1) + nrowc*(j - 1)
     &                     + nrowc*ncolc*(ivar-1)
c
c     # index into 19th component of aux = topo:
      iauxc(i,j) =  locauxc + (i - 1) + nrowc*(j - 1)
     &                     + nrowc*ncolc*(19-1)

      sticksout(iplo,iphi,jplo,jphi)  =
     &            (iplo .lt. 0 .or. jplo .lt. 0 .or.
     &             iphi .ge. iregsz(levc) .or. jphi .ge. jregsz(levc))
c
c We begin by filling values for grids at level level. If all values can be
c filled in this way, we return;

c      write(6,*) 'entering filpatch2'
c      write(49,*) 'entering filpatch2'

        hxf     = hxposs(level)
        hyf     = hyposs(level)
        xlp     = xlower + ilo*hxf
        xrp     = xlower + (ihi+1)*hxf
        ybp     = ylower + jlo*hyf
        ytp     = ylower + (jhi+1)*hyf
        nrowp   = ihi - ilo + 1
        ncolp   = jhi - jlo + 1
        locuse  = igetsp(nrowp*ncolp)


c 2/27/02 : added naux to intfil call.
        call intfil
     &  (valbig,mitot,mjtot,time,locuse,nrowst,ncolst,
     &   ilo,ihi,jlo,jhi,level,nvar,naux)
c
c Trimbd returns set = true if all of the entries are filled (=1.).
c set = false, otherwise. If set = true, then no other levels are
c are required to interpolate, and we return.
c
c Note that the used array is filled entirely in intfil, i.e. the
c marking done there also takes into account the points filled by
c the boundary conditions. bc2amr will be called later (from bound), after
c all 4 boundary pieces filled.

        call trimbd(alloc(locuse),nrowp,ncolp,set,il,ir,jb,jt)

        if (set) then
          call bc2amr(valbig,aux,mitot,mjtot,nvar,naux,
     1                 hxf,hyf,level,time,
     2                 xlp,xrp,ybp,ytp,
     3                 xlower,ylower,xupper,yupper,
     4                 xperdom,yperdom,spheredom)
           call reclam(locuse,nrowp*ncolp)
c          write(49,*) 'set=true: leaving filpatch2'
           return
        else if (level .eq. 1) then
           write(outunit,*)" error in filpatch - level 1 not set"
           write(outunit,900) nrowst,ncolst
           write(*,*)" error in filpatch - level 1 not set"
           write(*,900) nrowst,ncolst
900        format("starting at row: ",i4," col ",i4)
           stop
        endif

c set = false. we will have to interpolate some values from coarser
c levels. We begin by initializing the level level arrays, so that we can use
c recursive formulation for interpolating.
c IS THIS TRUE ? - the fine grid patch remaining unfilled is always
c anchored to a coarse cell.

        levc = level - 1
        hxc  = hxposs(levc)
        hyc  = hyposs(levc)

        isl  = il + ilo - 1
        isr  = ir + ilo - 1
        jsb  = jb + jlo - 1
        jst  = jt + jlo - 1
c
c       coarsen
        lratiox = intratx(levc)
        lratioy = intraty(levc)

        iplo   = (isl-lratiox  +nghost*lratiox)/lratiox - nghost
        jplo   = (jsb-lratioy  +nghost*lratioy)/lratioy - nghost
        iphi   = (isr+lratiox  )/lratiox
        jphi   = (jst+lratioy  )/lratioy

        xlc  =  xlower + iplo*hxc
        ybc  =  ylower + jplo*hyc
        xrc  =  xlower + (iphi+1)*hxc
        ytc  =  ylower + (jphi+1)*hyc

        nrowc   =  iphi - iplo + 1
        ncolc   =  jphi - jplo + 1
        ntot    = nrowc*ncolc*(nvar+naux)
        loccrse = igetsp(ntot)
        locauxc = loccrse + nrowc*ncolc*nvar
        if (naux.gt.0) then
              maxmx = nrowc - 2*nghost
              mx = maxmx
              maxmy = ncolc - 2*nghost
              my = maxmy
              xl = xlc + nghost*hxc
              yb = ybc + nghost*hyc
              call setaux(maxmx,maxmy,nghost,mx,my,xl,yb,hxc,hyc,
     &                    naux,alloc(locauxc))
        endif


        if ((xperdom .or. (yperdom.or.spheredom)) .and.
     &       sticksout(iplo,iphi,jplo,jphi)) then
            call prefil3(levc,nvar,alloc(loccrse),alloc(locauxc),naux,
     1                    time,nrowc,ncolc,1,1,
     2                    iplo,iphi,jplo,jphi)
        else
          call filpatch3(levc,nvar,alloc(loccrse),alloc(locauxc),naux,
     1                   time,nrowc,ncolc,1,1,
     2                   iplo,iphi,jplo,jphi)
        endif


c       interpolate back up

20      continue


c       #loop through all fine cells interpolating eta,hu,hv

        toldry= drytolerance

        do 100 iff = 1,nrowp
          ic = 2 + (iff - (isl - ilo) - 1)/lratiox
          eta1 = (-0.5d0+dble(mod(iff-1,lratiox)))/dble(lratiox)

        do 100 jf  = 1,ncolp
          jc = 2 + (jf -(jsb-jlo)-1)/lratioy
          eta2 = (-0.5d0+dble(mod(jf -1,lratioy)))/dble(lratioy)

           flag = alloc(iadflag(iff,jf))
           if (flag .eq. 0.0) then
                 

c          # 8 coarse values surrounding the current coarse value are set
                coarsevelmax(1)=-1.d99
                coarsevelmax(2)=-1.d99
                coarsevelmin(1)=1.d99
                coarsevelmin(2)=1.d99

                wetcount=0.d0
                etaave=0.d0
                sxlimit=1.d0
                sylimit=1.d0

                do ii=-1,1
                do jj=-1,1
                if (ii*jj.eq.0) then 
                  coarseb(2+ii,2+jj)= alloc(iauxc(ic+ii,jc+jj))
                  do ivar=1,nvar
                   coarseq(2+ii,2+jj,ivar)=
     &                            alloc(ivalc(ic+ii,jc+jj,ivar))
                  enddo
                  coarseq(2+ii,2+jj,1)=max(0.d0,coarseq(2+ii,2+jj,1))
                  coarseeta(2+ii,2+jj)=coarseq(2+ii,2+jj,1)
     &                          +coarseb(2+ii,2+jj)
c                 FOR DEBUG:
                  if (.false.) then
                  if (dabs(coarseeta(2+ii,2+jj) - sealevel).gt.1.d-8)
     &              then
                       write(49,491) iff,jf,ic,jc,ii,jj,
     &                     coarseeta(2+ii,2+jj),coarseq(2+ii,2+jj,1),
     &                          coarseb(2+ii,2+jj)

  491                  format(6i5,3d17.10)
                    endif
                  endif

                  if (coarseq(2+ii,2+jj,1).le.toldry) then
                    coarseu=0.d0
                    coarsev=0.d0
                    coarsew=0.d0
                    coarseq(2+ii,2+jj,2)=0.d0
                    coarseq(2+ii,2+jj,3)=0.d0
                    coarseq(2+ii,2+jj,4)=0.d0
                    coarseinterp(2+ii,2+jj,1)=sealevel
                  else
                    wetcount=wetcount+1.d0
                    etaave=etaave + coarseeta(2+ii,2+jj)
                    coarseu=coarseq(2+ii,2+jj,2)/coarseq(2+ii,2+jj,1)
                    coarsev=coarseq(2+ii,2+jj,3)/coarseq(2+ii,2+jj,1)
                    coarsew=coarseq(2+ii,2+jj,4)/coarseq(2+ii,2+jj,1)
                    coarseinterp(2+ii,2+jj,1)=coarseeta(2+ii,2+jj)
                  endif

                  coarseinterp(2+ii,2+jj,2)=coarseq(2+ii,2+jj,2)
                  coarseinterp(2+ii,2+jj,3)=coarseq(2+ii,2+jj,3)
                  coarseinterp(2+ii,2+jj,4)=coarseq(2+ii,2+jj,4)

                  coarsevelmax(1)=max(coarseu,coarsevelmax(1))
                  coarsevelmin(1)=min(coarseu,coarsevelmin(1))
                  coarsevelmax(2)=max(coarsev,coarsevelmax(2))
                  coarsevelmin(2)=min(coarsev,coarsevelmin(2))
                  coarsevelmax(3)=max(coarsew,coarsevelmax(3))
                  coarsevelmin(3)=min(coarsew,coarsevelmin(3))
                endif
                enddo
                enddo


c:::::::::::::::::::limited slope interpolation ::::::::::::
                do ivar = 1,nvar
                   s1p=coarseinterp(3,2,ivar)-coarseinterp(2,2,ivar)
                   s1m=coarseinterp(2,2,ivar)-coarseinterp(1,2,ivar)
                   slopex=dmin1(dabs(s1p),dabs(s1m))*dsign(1.d0,
     &                 coarseinterp(3,2,ivar)-coarseinterp(1,2,ivar))
                   if (s1m*s1p.le.0.d0) then
                      slopex=0.d0
                   endif

                   s1p=coarseinterp(2,3,ivar)-coarseinterp(2,2,ivar)
                   s1m=coarseinterp(2,2,ivar)-coarseinterp(2,1,ivar)
                   slopey=dmin1(dabs(s1p),dabs(s1m))*dsign(1.d0,
     &                 coarseinterp(2,3,ivar)-coarseinterp(2,1,ivar))
                   if (s1m*s1p.le.0.d0) then
                      slopey=0.d0
                   endif

                   if (.false.) then 
                   do kk=-1,1
                      if (coarseq(2+kk,2,1).lt.toldry) then
                         sxlimit=0.d0
                      endif

                      if (coarseq(2,2+kk,1).lt.toldry) then
                         sylimit=0.d0
                      endif
                   enddo
                   endif

                   slopex=slopex*sxlimit
                   slopey=slopey*sylimit

                   fineval(ivar)=coarseinterp(2,2,ivar) + eta1*slopex
     &                  + eta2*slopey
                   if (ivar.eq.1) then
                      fineval(1)=fineval(1)
     &                     -aux(iff+nrowst-1,jf+ncolst-1,19)
                      fineval(1)=max(fineval(1),0.d0)
                   else
                      redo=.false.
                      if (fineval(1).gt.toldry) then
                         velfine(ivar-1)=fineval(ivar)/fineval(1)
                      else
                         redo=.true.
                         velfine(ivar-1)=0.d0
                      endif

                      if ((velfine(ivar-1).gt.coarsevelmax(ivar-1).or.
     &                  velfine(ivar-1).lt.coarsevelmin(ivar-1))
     &                            .or.redo) then

                          if (coarseq(2,2,1).gt.toldry) then
                           fineval(ivar)=fineval(1)*coarseq(2,2,ivar)/
     &                         coarseq(2,2,1)
                          else
                           fineval(ivar)=0.d0
                          endif
                      endif
                   endif
                  valbig(iff+nrowst-1,jf+ncolst-1,ivar)=fineval(ivar)
                enddo

         endif
 100     continue


        call bc2amr(valbig,aux,mitot,mjtot,nvar,naux,
     1              hxf,hyf,level,time,
     2              xlp,xrp,ybp,ytp,
     3              xlower,ylower,xupper,yupper,
     4                 xperdom,yperdom,spheredom)

        call reclam(loccrse,ntot)

        call reclam(locuse,nrowp*ncolp)
c       write(49,*) 'leaving filpatch2'

        return
        end
