
# Run this after running amr_tests.py
# Depends on output.mx50mxnest3 and output.mx800mxnest1.


def plotclaw(outdir):
    """
    Basic plotting script.  Execute from unix by
      $ python plotclaw.py
    Additional plot parameters are set in setplot.py.
    """
    
    from pyclaw.data import ClawPlotData
    from pyclaw.plotting import printframes

    plotdata = ClawPlotData()
    plotdata.setplot = 'setplot_figure6.py'   # module used to initialize other params

    # Parameters used only when creating html and/or pdf hardcopy
    # via pyclaw.plotting.printframes:
    plotdata.outdir = outdir                 # directory where fort.* is
    plotdata.plotdir = outdir                # directory where plots will appear
    plotdata.printfigs = True                # print figures?
    plotdata.print_format = 'png'            # file format
    plotdata.print_framenos = [0,12,20]      # list of frames to print
    plotdata.print_fignos = 'all'            # list of figures to print
    plotdata.html = True                     # create html files of plots?
    plotdata.latex = True                    # create latex file of plots?
    plotdata.latex_framesperline = 1         # layout of plots
    plotdata.latex_figsperline = 2           # layout of plots
    plotdata.latex_pdf = False               # also run pdflatex?

    # create html files of plots:
    printframes(plotdata, verbose=False)

#----------------------------------------------------------

if __name__=='__main__':
    # if executed at command line prompt, simply call the function:
    for outdir in ['output.mx50mxnest3', 'output.mx800mxnest1']:
	plotclaw(outdir)
	print "created png files of form frameNfig6.png in ",outdir
