#!/usr/bin/env python
# encoding: utf-8
#  =====================================================================
#  Package:     pyclaw
#  File:        __init__.py
#  Created:     Feb 19, 2008
#  Author:      Kyle Mandli
#  ======================================================================
"""Main pyclaw package"""

import os
import logging, logging.config

# Default logging configuration file
DEFAULT_LOG_CONFIG_PATH = os.path.join(os.path.dirname(__file__),'log.config')

# Setup loggers
logging.config.fileConfig(DEFAULT_LOG_CONFIG_PATH)

# Solver 
__all__ = ['ClawController','data.ClawGridData','data.ClawRunData',
           'grid.ClawGrid','solution.ClawSolution']