#!/usr/bin/env python
# encoding: utf-8
#  ======================================================================
#  Package:     pyclaw
#  File:        error.py
#  Created:     Feb 7, 2008
#  Author:      Kyle Mandli
#  ======================================================================
"""ClawError class

Pyclaw exception class handles any exceptions that should be raised that
are specific to pyclaw.

"""

class ClawError(Exception):
    def __init__(self,message):
        self.value = message
    def __str__(self):
        return repr(self.value)

class ClawRiemannError(Exception):
    def __init__(self,message,info):
        self.message = message
        self.info = info
    def __str__(self):
        return "Message:  %s \nInfo:  %s" % (self.message,self.info)

# This class may be subclassed for more information, only here more as a
# place holder!
