#!/usr/bin/env python
# encoding: utf-8
#  ======================================================================
#  Package:     pyclaw.io
#  File:        binary.py
#  Created:     Feb 17, 2009
#  Author:      Kyle Mandli
#  ======================================================================
"""
binary.py

Created by Kyle Mandli on 2009-02-17.
Copyright (c) 2009 University of Washington. All rights reserved.

Routines for reading and writing a generic binary output file
"""

import os,sys
import logging

from numpy.core.multiarray import empty
from pyclaw.grid import ClawGrid

logger = logging.getLogger('io')

def write_binary(solution,frame,path,file_prefix='claw',write_aux=False,
                    options={}):
    """Write out a binary data file representation of solution
    
    Arguments:
      solution = Pyclaw object to be output
      frame = Frame number
      path = Root path
      file_prefix = Prefix for the file name, defaults to standard 'claw'
      write_aux = Boolean controlling whether the associated auxillary array 
        should be written out.
      options = Optional argument dictionary which can contain the following
        keyword/value pairs:
            EMPTY
    
    """
    
    # Option parsing
    option_defaults = {}
    for (k,v) in option_defaults.iteritems():
        if options.has_key(k):
            exec("%s = options['%s']" % (k,k))
        else:
            exec('%s = v' % k)
    
    
def read_binary(solution,frame,path='./',file_prefix='claw',read_aux=True,
                options={}):
    """Read in a set of binary data files into solution
    
    Arguments:
        solution = Solution object to read the data into
        frame = Frame number to be read in
        path = Path to the current directory of the file
        file_prefix = Prefix of the files to be read in (e.g. fort.q**** where
            file_prefix='fort')
        read_aux = Boolean controlling whether or not an auxillary file will 
            try to be read in.
        options = Dictionary of options particular to this format which
            includes the following key/value pairs: 
                EMPTY
    
    """
    
    # Option parsing
    option_defaults = {}
    for (k,v) in option_defaults.iteritems():
        if options.has_key(k):
            exec("%s = options['%s']" % (k,k))
        else:
            exec('%s = v' % k)