
def plotclaw(ndim):
    """
    Can be called from command line on either linux or cygwin.
    Assumes that setplot.py exists and will be used to set plotdata.
    Used by pyclaw.ClawController.plotclaw() method.

    """

    import os, sys, shelve

    # for cygwin...  
    sys.path.insert(0, 'C:/cygwin/home/rjl/claw/trunk/claw/python')

    from pyclaw import plotting, data
    
    plotdata =  data.ClawPlotData(ndim)
    plotdata.setplot = True

    try:
        plotting.plotclaw2html(plotdata)
    except:
        print 'Error when calling plotclaw2html from pyclaw.plotclaw'
        sys.exit(1)
    
    
if __name__ == '__main__':
    # if called from command line...
    import os,sys
    if len(sys.argv) > 2:
	datadir = sys.argv[2]
        os.chdir(datadir)
    if len(sys.argv) > 1:
        ndim = int(sys.argv[1])
        plotclaw(ndim)
    else:
        print '*** Error in plotclaw:  You must specify ndim'
