
c
c
c =========================================================
      subroutine src1(maxmx,meqn,mbc,mx,xlower,dx,q,maux,aux,t,dt)
c =========================================================
      implicit double precision (a-h,o-z)
      dimension q(1-mbc:maxmx+mbc, meqn)
      dimension aux(1-mbc:maxmx+mbc, maux)
      dimension qstar(3)
      common /comsphere/ Rsphere, Omega
c
c     geometric source term + Coriolis force
c
      dt2 = dt/2.d0

      do i = 1-mbc, mx+mbc

         xc = xlower + (i-0.5d0)*dx

c        # Stage 1
         h = q(i,1)
         u = q(i,2)/h
         v = q(i,3)/h
         fCor = 2.d0*Omega*dsin(xc) 

         rhs1 = h*u*dtan(xc) / Rsphere
         rhs2 = (h*u*u*dtan(xc) - h*v*v*dtan(xc)) / Rsphere
         rhs3 = 2.d0*h*u*v*dtan(xc) / Rsphere

         rhs2 = rhs2 - h*v*fCor
         rhs3 = rhs3 + h*u*fCor

         qstar(1) = q(i,1) + dt2*rhs1
         qstar(2) = q(i,2) + dt2*rhs2
         qstar(3) = q(i,3) + dt2*rhs3


c        # Stage 2
         h = qstar(1)
         u = qstar(2)/h
         v = qstar(3)/h

         rhs1 = h*u*dtan(xc) / Rsphere
         rhs2 = (h*u*u*dtan(xc) - h*v*v*dtan(xc)) / Rsphere
         rhs3 = 2.d0*h*u*v*dtan(xc) / Rsphere

         rhs2 = rhs2 - h*v*fCor
         rhs3 = rhs3 + h*u*fCor

         q(i,1) = q(i,1) + dt*rhs1
         q(i,2) = q(i,2) + dt*rhs2
         q(i,3) = q(i,3) + dt*rhs3
      enddo
c

      return
      end
